import accordion from 'primevue/themes/primeone/base/accordion';
import autocomplete from 'primevue/themes/primeone/base/autocomplete';
import avatar from 'primevue/themes/primeone/base/avatar';
import badge from 'primevue/themes/primeone/base/badge';
import blockui from 'primevue/themes/primeone/base/blockui';
import breadcrumb from 'primevue/themes/primeone/base/breadcrumb';
import button from 'primevue/themes/primeone/base/button';
import calendar from 'primevue/themes/primeone/base/calendar';
import card from 'primevue/themes/primeone/base/card';
import carousel from 'primevue/themes/primeone/base/carousel';
import cascadeselect from 'primevue/themes/primeone/base/cascadeselect';
import checkbox from 'primevue/themes/primeone/base/checkbox';
import chip from 'primevue/themes/primeone/base/chip';
import chips from 'primevue/themes/primeone/base/chips';
import colorpicker from 'primevue/themes/primeone/base/colorpicker';
import confirmdialog from 'primevue/themes/primeone/base/confirmdialog';
import confirmpopup from 'primevue/themes/primeone/base/confirmpopup';
import contextmenu from 'primevue/themes/primeone/base/contextmenu';
import datatable from 'primevue/themes/primeone/base/datatable';
import dataview from 'primevue/themes/primeone/base/dataview';
import dialog from 'primevue/themes/primeone/base/dialog';
import divider from 'primevue/themes/primeone/base/divider';
import dock from 'primevue/themes/primeone/base/dock';
import dropdown from 'primevue/themes/primeone/base/dropdown';
import editor from 'primevue/themes/primeone/base/editor';
import fieldset from 'primevue/themes/primeone/base/fieldset';
import fileupload from 'primevue/themes/primeone/base/fileupload';
import floatlabel from 'primevue/themes/primeone/base/floatlabel';
import galleria from 'primevue/themes/primeone/base/galleria';
import global from 'primevue/themes/primeone/base/global';
import iconfield from 'primevue/themes/primeone/base/iconfield';
import image from 'primevue/themes/primeone/base/image';
import inlinemessage from 'primevue/themes/primeone/base/inlinemessage';
import inplace from 'primevue/themes/primeone/base/inplace';
import inputgroup from 'primevue/themes/primeone/base/inputgroup';
import inputnumber from 'primevue/themes/primeone/base/inputnumber';
import inputotp from 'primevue/themes/primeone/base/inputotp';
import inputswitch from 'primevue/themes/primeone/base/inputswitch';
import inputtext from 'primevue/themes/primeone/base/inputtext';
import knob from 'primevue/themes/primeone/base/knob';
import listbox from 'primevue/themes/primeone/base/listbox';
import megamenu from 'primevue/themes/primeone/base/megamenu';
import menu from 'primevue/themes/primeone/base/menu';
import menubar from 'primevue/themes/primeone/base/menubar';
import message from 'primevue/themes/primeone/base/message';
import metergroup from 'primevue/themes/primeone/base/metergroup';
import multiselect from 'primevue/themes/primeone/base/multiselect';
import orderlist from 'primevue/themes/primeone/base/orderlist';
import organizationchart from 'primevue/themes/primeone/base/organizationchart';
import overlaypanel from 'primevue/themes/primeone/base/overlaypanel';
import paginator from 'primevue/themes/primeone/base/paginator';
import panel from 'primevue/themes/primeone/base/panel';
import panelmenu from 'primevue/themes/primeone/base/panelmenu';
import password from 'primevue/themes/primeone/base/password';
import picklist from 'primevue/themes/primeone/base/picklist';
import progressbar from 'primevue/themes/primeone/base/progressbar';
import progressspinner from 'primevue/themes/primeone/base/progressspinner';
import radiobutton from 'primevue/themes/primeone/base/radiobutton';
import rating from 'primevue/themes/primeone/base/rating';
import scrollpanel from 'primevue/themes/primeone/base/scrollpanel';
import scrolltop from 'primevue/themes/primeone/base/scrolltop';
import selectbutton from 'primevue/themes/primeone/base/selectbutton';
import sidebar from 'primevue/themes/primeone/base/sidebar';
import skeleton from 'primevue/themes/primeone/base/skeleton';
import slider from 'primevue/themes/primeone/base/slider';
import speeddial from 'primevue/themes/primeone/base/speeddial';
import splitbutton from 'primevue/themes/primeone/base/splitbutton';
import splitter from 'primevue/themes/primeone/base/splitter';
import stepper from 'primevue/themes/primeone/base/stepper';
import steps from 'primevue/themes/primeone/base/steps';
import tabmenu from 'primevue/themes/primeone/base/tabmenu';
import tabview from 'primevue/themes/primeone/base/tabview';
import tag from 'primevue/themes/primeone/base/tag';
import terminal from 'primevue/themes/primeone/base/terminal';
import textarea from 'primevue/themes/primeone/base/textarea';
import tieredmenu from 'primevue/themes/primeone/base/tieredmenu';
import timeline from 'primevue/themes/primeone/base/timeline';
import toast from 'primevue/themes/primeone/base/toast';
import togglebutton from 'primevue/themes/primeone/base/togglebutton';
import toolbar from 'primevue/themes/primeone/base/toolbar';
import tooltip from 'primevue/themes/primeone/base/tooltip';
import tree from 'primevue/themes/primeone/base/tree';
import treeselect from 'primevue/themes/primeone/base/treeselect';
import treetable from 'primevue/themes/primeone/base/treetable';

var index = {
  global: global,
  components: {
    accordion: accordion,
    autocomplete: autocomplete,
    avatar: avatar,
    badge: badge,
    blockui: blockui,
    breadcrumb: breadcrumb,
    button: button,
    calendar: calendar,
    card: card,
    carousel: carousel,
    cascadeselect: cascadeselect,
    checkbox: checkbox,
    chip: chip,
    chips: chips,
    colorpicker: colorpicker,
    confirmdialog: confirmdialog,
    confirmpopup: confirmpopup,
    contextmenu: contextmenu,
    dataview: dataview,
    datatable: datatable,
    dialog: dialog,
    divider: divider,
    dropdown: dropdown,
    dock: dock,
    editor: editor,
    fieldset: fieldset,
    fileupload: fileupload,
    floatlabel: floatlabel,
    galleria: galleria,
    iconfield: iconfield,
    image: image,
    inlinemessage: inlinemessage,
    inplace: inplace,
    inputgroup: inputgroup,
    inputnumber: inputnumber,
    inputotp: inputotp,
    inputswitch: inputswitch,
    inputtext: inputtext,
    knob: knob,
    listbox: listbox,
    megamenu: megamenu,
    menu: menu,
    menubar: menubar,
    message: message,
    metergroup: metergroup,
    multiselect: multiselect,
    orderlist: orderlist,
    organizationchart: organizationchart,
    overlaypanel: overlaypanel,
    paginator: paginator,
    password: password,
    panel: panel,
    panelmenu: panelmenu,
    picklist: picklist,
    progressbar: progressbar,
    progressspinner: progressspinner,
    radiobutton: radiobutton,
    rating: rating,
    scrollpanel: scrollpanel,
    scrolltop: scrolltop,
    selectbutton: selectbutton,
    skeleton: skeleton,
    sidebar: sidebar,
    slider: slider,
    speeddial: speeddial,
    splitter: splitter,
    splitbutton: splitbutton,
    steps: steps,
    stepper: stepper,
    tabmenu: tabmenu,
    tabview: tabview,
    textarea: textarea,
    tieredmenu: tieredmenu,
    tag: tag,
    terminal: terminal,
    timeline: timeline,
    togglebutton: togglebutton,
    tree: tree,
    treeselect: treeselect,
    treetable: treetable,
    toast: toast,
    toolbar: toolbar
  },
  directives: {
    tooltip: tooltip
  }
};

export { index as default };
