'use strict';

var index = {
  css: function css(_ref) {
    var dt = _ref.dt;
    return "\n.p-cascadeselect {\n    display: inline-flex;\n    cursor: pointer;\n    position: relative;\n    user-select: none;\n    background: ".concat(dt('cascadeselect.background'), ";\n    border: 1px solid ").concat(dt('cascadeselect.border.color'), ";\n    transition: background-color ").concat(dt('transition.duration'), ", color ").concat(dt('transition.duration'), ", border-color ").concat(dt('transition.duration'), ", outline-color ").concat(dt('transition.duration'), ";\n    border-radius: ").concat(dt('rounded.base'), ";\n    outline-color: transparent;\n    box-shadow: ").concat(dt('cascadeselect.box.shadow'), ";\n}\n\n.p-cascadeselect:not(.p-disabled):hover {\n    border-color: ").concat(dt('cascadeselect.hover.border.color'), ";\n}\n\n.p-cascadeselect:not(.p-disabled).p-focus {\n    border-color: ").concat(dt('cascadeselect.focus.border.color'), ";\n    outline: 0 none;\n}\n\n.p-cascadeselect.p-variant-filled {\n    background: ").concat(dt('cascadeselect.filled.background'), ";\n}\n\n.p-cascadeselect.p-variant-filled.p-focus {\n    background: ").concat(dt('cascadeselect.filled.focus.background'), ";\n}\n\n.p-cascadeselect.p-invalid {\n    border-color: ").concat(dt('cascadeselect.invalid.border.color'), ";\n}\n\n.p-cascadeselect.p-disabled {\n    opacity: 1;\n    background: ").concat(dt('cascadeselect.disabled.background'), ";\n}\n\n.p-cascadeselect-trigger {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    flex-shrink: 0;\n    background: transparent;\n    color: ").concat(dt('cascadeselect.toggle.color'), ";\n    width: 2.5rem;\n    border-top-right-radius: ").concat(dt('rounded.base'), ";\n    border-bottom-right-radius: ").concat(dt('rounded.base'), ";\n}\n\n.p-cascadeselect-label {\n    display: block;\n    white-space: nowrap;\n    overflow: hidden;\n    flex: 1 1 auto;\n    width: 1%;\n    padding: 0.5rem 0.75rem;\n    text-overflow: ellipsis;\n    cursor: pointer;\n    color: ").concat(dt('cascadeselect.color'), ";\n    background: transparent;\n    border: 0 none;\n    outline: 0 none;\n}\n\n.p-cascadeselect-label.p-placeholder {\n    color: ").concat(dt('cascadeselect.placeholder.color'), ";\n}\n\n.p-cascadeselect-clearable .p-cascadeselect-label {\n    padding-right: 1.75rem;\n}\n\n.p-cascadeselect.p-disabled .p-cascadeselect-label {\n    color: ").concat(dt('cascadeselect.disabled.color'), ";\n}\n\n.p-cascadeselect-label-empty {\n    overflow: hidden;\n    visibility: hidden;\n}\n\n.p-fluid .p-cascadeselect {\n    display: flex;\n}\n\n.p-fluid .p-cascadeselect .p-cascadeselect-label {\n    width: 1%;\n}\n\n.p-cascadeselect-panel {\n    background: ").concat(dt('cascadeselect.overlay.background'), ";\n    color: ").concat(dt('cascadeselect.overlay.color'), ";\n    border: 1px solid ").concat(dt('cascadeselect.overlay.border.color'), ";\n    border-radius: ").concat(dt('rounded.base'), ";\n    box-shadow: 0 4px 6px -1px rgba(0, 0, 0, 0.1), 0 2px 4px -2px rgba(0, 0, 0, 0.1);\n}\n\n.p-cascadeselect .p-cascadeselect-panel {\n    min-width: 100%;\n}\n\n.p-cascadeselect-sublist {\n    position: absolute;\n    min-width: 100%;\n    z-index: 1;\n    display: none;\n}\n\n.p-cascadeselect-items {\n    margin: 0;\n    padding: 0;\n    list-style-type: none;\n    min-width: 100%;\n    padding: 0.25rem 0.25rem;\n}\n\n.p-cascadeselect-item {\n    cursor: pointer;\n    font-weight: normal;\n    white-space: nowrap;\n    margin: 2px 0;\n    border: 0 none;\n    color: ").concat(dt('cascadeselect.item.color'), ";\n    background: transparent;\n    transition: background-color ").concat(dt('transition.duration'), ", color ").concat(dt('transition.duration'), ", border-color ").concat(dt('transition.duration'), ", box-shadow ").concat(dt('transition.duration'), ", outline-color ").concat(dt('transition.duration'), ";\n    border-radius: ").concat(dt('rounded.sm'), ";\n}\n\n.p-cascadeselect-item:first-child {\n    margin-top: 0;\n}\n\n.p-cascadeselect-item:last-child {\n    margin-bottom: 0;\n}\n\n.p-cascadeselect-item:not(.p-highlight):not(.p-disabled).p-focus {\n    background: ").concat(dt('cascadeselect.item.focus.background'), ";\n    color: ").concat(dt('cascadeselect.item.focus.color'), ";\n}\n\n.p-cascadeselect-item:not(.p-highlight):not(.p-disabled).p-focus .p-cascadeselect-group-icon {\n    color: ").concat(dt('cascadeselect.item.icon.focus.color'), ";\n}\n\n.p-cascadeselect-item.p-highlight {\n    background: ").concat(dt('cascadeselect.item.selected.background'), ";\n    color: ").concat(dt('cascadeselect.item.selected.color'), ";\n}\n\n.p-cascadeselect-item.p-highlight.p-focus {\n    background: ").concat(dt('cascadeselect.item.selected.focus.background'), ";\n    color: ").concat(dt('cascadeselect.item.selected.focus.color'), ";\n}\n\n.p-cascadeselect-item-active {\n    overflow: visible;\n    background: ").concat(dt('cascadeselect.item.focus.background'), ";\n    color: ").concat(dt('cascadeselect.item.focus.color'), ";\n}\n\n.p-cascadeselect-item-active > .p-cascadeselect-sublist {\n    display: block;\n    left: 100%;\n    top: 0;\n}\n\n.p-cascadeselect-item-content {\n    display: flex;\n    align-items: center;\n    overflow: hidden;\n    position: relative;\n    padding: 0.5rem 0.75rem;\n}\n\n.p-cascadeselect-group-icon {\n    margin-left: auto;\n    font-size: 0.875rem;\n    color: ").concat(dt('cascadeselect.item.icon.color'), ";\n}\n\n.p-cascadeselect-enter-from,\n.p-cascadeselect-leave-active {\n    opacity: 0;\n}\n\n.p-cascadeselect-enter-active {\n    transition: opacity 150ms;\n}\n");
  }
};

module.exports = index;
