'use strict';

var index = {
  css: function css(_ref) {
    var dt = _ref.dt;
    return "\n.p-dropdown {\n    display: inline-flex;\n    cursor: pointer;\n    position: relative;\n    user-select: none;\n    background: ".concat(dt('dropdown.background'), ";\n    border: 1px solid ").concat(dt('dropdown.border.color'), ";\n    transition: background-color ").concat(dt('transition.duration'), ", color ").concat(dt('transition.duration'), ", border-color ").concat(dt('transition.duration'), ", outline-color ").concat(dt('transition.duration'), ";\n    border-radius: ").concat(dt('rounded.base'), ";\n    outline-color: transparent;\n    box-shadow: ").concat(dt('dropdown.box.shadow'), ";\n}\n\n.p-dropdown:not(.p-disabled):hover {\n    border-color: ").concat(dt('dropdown.hover.border.color'), ";\n}\n\n.p-dropdown:not(.p-disabled).p-focus {\n    border-color:").concat(dt('dropdown.focus.border.color'), ";\n    outline: 0 none;\n}\n\n.p-dropdown.p-variant-filled {\n    background: ").concat(dt('dropdown.filled.background'), ";\n}\n\n.p-dropdown.p-variant-filled.p-focus {\n    background: ").concat(dt('dropdown.filled.focus.background'), ";\n}\n\n.p-dropdown.p-invalid {\n    border-color: ").concat(dt('dropdown.invalid.border.color'), ";\n}\n\n.p-dropdown.p-disabled {\n    opacity: 1;\n    background: ").concat(dt('dropdown.disabled.background'), ";\n}\n\n.p-dropdown-clear-icon {\n    position: absolute;\n    top: 50%;\n    margin-top: -0.5rem;\n    color: #94a3b8;\n    right: 2.5rem;\n}\n\n.p-dropdown-trigger {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    flex-shrink: 0;\n    background: transparent;\n    color: ").concat(dt('dropdown.toggle.color'), ";\n    width: 2.5rem;\n    border-top-right-radius: ").concat(dt('rounded.base'), ";\n    border-bottom-right-radius: ").concat(dt('rounded.base'), ";\n}\n\n.p-dropdown-label {\n    display: block;\n    white-space: nowrap;\n    overflow: hidden;\n    flex: 1 1 auto;\n    width: 1%;\n    padding: 0.5rem 0.75rem;\n    text-overflow: ellipsis;\n    cursor: pointer;\n    color: ").concat(dt('dropdown.color'), ";\n    background: transparent;\n    border: 0 none;\n    outline: 0 none;\n}\n\n.p-dropdown-label.p-placeholder {\n    color: ").concat(dt('dropdown.placeholder.color'), ";\n}\n\n.p-dropdown-clearable .p-dropdown-label {\n    padding-right: 1.75rem;\n}\n\n.p-dropdown.p-disabled .p-dropdown-label {\n    color: ").concat(dt('dropdown.disabled.color'), ";\n}\n\n.p-dropdown-label-empty {\n    overflow: hidden;\n    opacity: 0;\n}\n\ninput.p-dropdown-label {\n    cursor: default;\n}\n\n.p-dropdown .p-dropdown-panel {\n    min-width: 100%;\n}\n\n.p-dropdown-panel {\n    position: absolute;\n    top: 0;\n    left: 0;\n    background: ").concat(dt('dropdown.overlay.background'), ";\n    color: ").concat(dt('dropdown.overlay.color'), ";\n    border: 1px solid ").concat(dt('dropdown.overlay.border.color'), ";\n    border-radius: ").concat(dt('rounded.base'), ";\n    box-shadow: 0 4px 6px -1px rgba(0, 0, 0, 0.1), 0 2px 4px -2px rgba(0, 0, 0, 0.1);\n}\n\n\n.p-dropdown-panel .p-dropdown-header {\n    padding: 0.5rem 0.5rem 0 0.5rem;\n}\n\n.p-dropdown-filter {\n    width: 100%;\n    padding-right: 1.75rem;\n    margin-right: -1.75rem;\n}\n\n.p-dropdown-filter-container {\n    position: relative;\n}\n\n.p-dropdown-filter-icon {\n    position: absolute;\n    top: 50%;\n    margin-top: -0.5rem;\n    right: 0.75rem;\n    color: ").concat(dt('dropdown.filter.icon.color'), ";\n}\n\n.p-dropdown-items-wrapper {\n    overflow: auto;\n}\n\n.p-dropdown-item-group {\n    cursor: auto;\n    margin: 0;\n    padding: 0.5rem 0.75rem;\n    background: ").concat(dt('dropdown.item.group.background'), ";\n    color: ").concat(dt('dropdown.item.group.color'), ";\n    font-weight: 600;\n}\n\n.p-dropdown-items {\n    margin: 0;\n    padding: 0;\n    list-style-type: none;\n    padding: 0.25rem 0.25rem;\n}\n\n.p-dropdown-item {\n    cursor: pointer;\n    font-weight: normal;\n    white-space: nowrap;\n    position: relative;\n    overflow: hidden;\n    display: flex;\n    align-items: center;\n    margin: 2px 0;\n    padding: 0.5rem 0.75rem;\n    border: 0 none;\n    color: ").concat(dt('dropdown.item.color'), ";\n    background: transparent;\n    transition: background-color ").concat(dt('transition.duration'), ", color ").concat(dt('transition.duration'), ", border-color ").concat(dt('transition.duration'), ", box-shadow ").concat(dt('transition.duration'), ", outline-color ").concat(dt('transition.duration'), ";\n    border-radius: ").concat(dt('rounded.sm'), ";\n}\n\n.p-dropdown-item:first-child {\n    margin-top: 0;\n}\n\n.p-dropdown-item:last-child {\n    margin-bottom: 0;\n}\n\n.p-dropdown-item:not(.p-highlight):not(.p-disabled).p-focus {\n    background: ").concat(dt('dropdown.item.focus.background'), ";\n    color: ").concat(dt('dropdown.item.focus.color'), ";\n}\n\n.p-dropdown-item.p-highlight {\n    background: ").concat(dt('dropdown.item.selected.background'), ";\n    color: ").concat(dt('dropdown.item.selected.color'), ";\n}\n\n.p-dropdown-item.p-highlight.p-focus {\n    background: ").concat(dt('dropdown.item.selected.focus.background'), ";\n    color: ").concat(dt('dropdown.item.selected.focus.color'), ";\n}\n\n.p-dropdown-check-icon {\n    position: relative;\n    margin-left: -0.375rem;\n    margin-right: 0.375rem;\n    color: ").concat(dt('dropdown.checkmark.color'), ";\n}\n\n.p-dropdown-empty-message {\n    padding: 0.5rem 0.75rem;\n    background: transparent;\n}\n\n.p-fluid .p-dropdown {\n    display: flex;\n}\n\n.p-fluid .p-dropdown .p-dropdown-label {\n    width: 1%;\n}\n");
  }
};

module.exports = index;
