'use strict';

var index = {
  css: function css(_ref) {
    var dt = _ref.dt;
    return "\n.p-treetable {\n    position: relative;\n}\n\n.p-treetable table {\n    border-collapse: collapse;\n    width: 100%;\n    table-layout: fixed;\n}\n\n.p-treetable .p-sortable-column {\n    cursor: pointer;\n    user-select: none;\n    outline-color: transparent;\n}\n\n.p-treetable .p-sortable-column .p-column-title,\n.p-treetable .p-sortable-column .p-sortable-column-icon,\n.p-treetable .p-sortable-column .p-sortable-column-badge {\n    vertical-align: middle;\n}\n\n.p-treetable .p-sortable-column .p-sortable-column-icon {\n    color: ".concat(dt('treetable.sort.icon.color'), ";\n    margin-left: 0.5rem;\n    transition: color ").concat(dt('transition.duration'), ";\n}\n\n.p-treetable .p-sortable-column .p-sortable-column-badge {\n    display: inline-flex;\n    align-items: center;\n    justify-content: center;\n    border-radius: 50%;\n    height: 1rem;\n    min-width: 1rem;\n    line-height: 1rem;\n    margin-left: 0.5rem;\n}\n\n.p-treetable .p-sortable-column:not(.p-highlight):hover {\n    background: ").concat(dt('treetable.header.cell.hover.background'), ";\n    color: ").concat(dt('treetable.header.cell.hover.color'), ";\n}\n\n.p-treetable .p-sortable-column:not(.p-highlight):hover .p-sortable-column-icon {\n    color: ").concat(dt('treetable.sort.icon.hover.color'), ";\n}\n\n.p-treetable .p-sortable-column.p-highlight {\n    background: ").concat(dt('highlight.background'), ";\n    color: ").concat(dt('highlight.color'), ";\n}\n\n.p-treetable .p-sortable-column:focus-visible {\n    outline: ").concat(dt('focus.ring.width'), " ").concat(dt('focus.ring.style'), " ").concat(dt('focus.ring.color'), ";\n    outline-offset: -1px;\n}\n\n.p-treetable .p-sortable-column.p-highlight .p-sortable-column-icon {\n    color: ").concat(dt('highlight.color'), ";\n}\n\n.p-treetable-responsive-scroll > .p-treetable-wrapper {\n    overflow-x: auto;\n}\n\n.p-treetable-responsive-scroll > .p-treetable-wrapper > table,\n.p-treetable-auto-layout > .p-treetable-wrapper > table {\n    table-layout: auto;\n}\n\n.p-treetable-hoverable-rows .p-treetable-tbody > tr {\n    cursor: pointer;\n}\n\n.p-treetable-resizable>.p-treetable-wrapper {\n    overflow-x: auto;\n}\n\n.p-treetable-resizable .p-treetable-thead>tr>th,\n.p-treetable-resizable .p-treetable-tfoot>tr>td,\n.p-treetable-resizable .p-treetable-tbody>tr>td {\n    overflow: hidden;\n}\n\n.p-treetable-resizable .p-resizable-column:not(.p-frozen-column) {\n    background-clip: padding-box;\n    position: relative;\n}\n\n.p-treetable-resizable-fit .p-resizable-column:last-child .p-column-resizer {\n    display: none;\n}\n\n.p-treetable .p-column-resizer {\n    display: block;\n    position: absolute;\n    top: 0;\n    right: 0;\n    margin: 0;\n    width: 0.5rem;\n    height: 100%;\n    padding: 0px;\n    cursor: col-resize;\n    border: 1px solid transparent;\n}\n\n.p-treetable .p-column-resizer-helper {\n    width: 1px;\n    position: absolute;\n    z-index: 10;\n    display: none;\n    background: ").concat(dt('treetable.resizer.color'), ";\n}\n\n.p-treetable .p-treetable-loading-overlay {\n    position: absolute;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    z-index: 2;\n}\n\n/* Scrollable */\n.p-treetable-scrollable .p-treetable-wrapper {\n    position: relative;\n    overflow: auto;\n}\n\n.p-treetable-scrollable .p-treetable-table {\n    display: block;\n}\n\n\n\n.p-treetable-scrollable .p-treetable-thead,\n.p-treetable-scrollable .p-treetable-tbody,\n.p-treetable-scrollable .p-treetable-tfoot {\n    display: block;\n}\n\n.p-treetable-scrollable .p-treetable-thead>tr,\n.p-treetable-scrollable .p-treetable-tbody>tr,\n.p-treetable-scrollable .p-treetable-tfoot>tr {\n    display: flex;\n    flex-wrap: nowrap;\n    width: 100%;\n}\n\n.p-treetable-scrollable .p-treetable-thead>tr>th,\n.p-treetable-scrollable .p-treetable-tbody>tr>td,\n.p-treetable-scrollable .p-treetable-tfoot>tr>td {\n    display: flex;\n    flex: 1 1 0;\n    align-items: center;\n}\n\n.p-treetable-scrollable .p-treetable-thead {\n    position: sticky;\n    top: 0;\n    z-index: 1;\n}\n\n.p-treetable-scrollable .p-treetable-tfoot {\n    position: sticky;\n    bottom: 0;\n    z-index: 1;\n}\n\n.p-treetable-scrollable .p-frozen-column {\n    position: sticky;\n    background: inherit;\n}\n\n.p-treetable-scrollable th.p-frozen-column {\n    z-index: 1;\n}\n\n.p-treetable-scrollable-both .p-treetable-thead>tr>th,\n.p-treetable-scrollable-both .p-treetable-tbody>tr>td,\n.p-treetable-scrollable-both .p-treetable-tfoot>tr>td,\n.p-treetable-scrollable-horizontal .p-treetable-thead>tr>th .p-treetable-scrollable-horizontal .p-treetable-tbody>tr>td,\n.p-treetable-scrollable-horizontal .p-treetable-tfoot>tr>td {\n    flex: 0 0 auto;\n}\n\n.p-treetable-flex-scrollable {\n    display: flex;\n    flex-direction: column;\n    height: 100%;\n}\n\n.p-treetable-flex-scrollable .p-treetable-wrapper {\n    display: flex;\n    flex-direction: column;\n    flex: 1;\n    height: 100%;\n}\n\n.p-treetable .p-treetable-scrollable-header {\n    background: ").concat(dt('treetable.header.background'), ";\n}\n\n.p-treetable .p-treetable-scrollable-footer {\n    background: ").concat(dt('treetable.footer.background'), ";\n}\n\n.p-treetable .p-paginator-top {\n    border-width: 0 0 1px 0;\n    border-radius: 0;\n}\n\n.p-treetable .p-paginator-bottom {\n    border-width: 0 0 1px 0;\n    border-radius: 0;\n}\n\n.p-treetable-header {\n    background: ").concat(dt('treetable.header.background'), ";\n    color: ").concat(dt('treetable.header.color'), ";\n    border: 1px solid ").concat(dt('treetable.header.border.color'), ";\n    border-width: 0 0 1px 0;\n    padding: 0.75rem 1rem;\n    font-weight: 600;\n}\n\n.p-treetable-footer {\n    background: ").concat(dt('treetable.footer.background'), ";\n    color: ").concat(dt('treetable.footer.color'), ";\n    border: 1px solid ").concat(dt('treetable.footer.border.color'), ";\n    border-width: 0 0 1px 0;\n    padding: 0.75rem 1rem;\n    font-weight: 600;\n}\n\n.p-treetable-thead > tr > th {\n    text-align: left;\n    padding: 0.75rem 1rem;\n    background: ").concat(dt('treetable.header.cell.background'), ";\n    border: 1px solid ").concat(dt('treetable.header.cell.border.color'), ";\n    border-width: 0 0 1px 0;\n    color: ").concat(dt('treetable.header.cell.color'), ");\n    font-weight: 600;\n    transition: background-color ").concat(dt('transition.duration'), ", color ").concat(dt('transition.duration'), ", border-color ").concat(dt('transition.duration'), ", box-shadow ").concat(dt('transition.duration'), ", outline-color ").concat(dt('transition.duration'), ";\n}\n\n.p-treetable-tbody > tr {\n    outline-color: transparent;\n    background: ").concat(dt('treetable.row.background'), ";\n    color: ").concat(dt('treetable.row.color'), ";\n    transition: background-color ").concat(dt('transition.duration'), ", color ").concat(dt('transition.duration'), ", border-color ").concat(dt('transition.duration'), ", box-shadow ").concat(dt('transition.duration'), ", outline-color ").concat(dt('transition.duration'), ";\n}\n\n.p-treetable-tbody > tr > td {\n    text-align: left;\n    border: 1px solid ").concat(dt('treetable.body.cell.border.color'), ";\n    border-width: 0 0 1px 0;\n    padding: 0.75rem 1rem;\n}\n\n.p-treetable-hoverable-rows .p-treetable-tbody > tr:not(.p-highlight):hover {\n    background: ").concat(dt('treetable.row.hover.background'), ";\n    color: ").concat(dt('treetable.row.hover.color'), ";\n}\n\n.p-treetable-tbody > tr.p-highlight {\n    background: ").concat(dt('highlight.background'), ";\n    color: ").concat(dt('highlight.color'), ";\n}\n\n.p-treetable-tbody > tr:has(+ .p-highlight) > td {\n    border-bottom-color: ").concat(dt('treetable.body.cell.selected.border.color'), ");\n}\n\n.p-treetable-tbody > tr.p-highlight > td {\n    border-bottom-color: ").concat(dt('treetable.body.cell.selected.border.color'), ");\n}\n\n.p-treetable-tbody > tr:focus-visible {\n    outline: 1px solid ").concat(dt('focus.ring.color'), ";\n    outline-offset: -1px;\n}\n\n.p-treetable-toggler {\n    cursor: pointer;\n    user-select: none;\n    display: inline-flex;\n    align-items: center;\n    justify-content: center;\n    vertical-align: middle;\n    overflow: hidden;\n    position: relative;\n    width: 1.75rem;\n    height: 1.75rem;\n    color: ").concat(dt('treetable.toggle.color'), ";\n    border: 0 none;\n    background: transparent;\n    border-radius: 50%;\n    transition: background-color ").concat(dt('transition.duration'), ", color ").concat(dt('transition.duration'), ", border-color ").concat(dt('transition.duration'), ", box-shadow ").concat(dt('transition.duration'), ", outline-color ").concat(dt('transition.duration'), ";\n    outline-color: transparent;\n    margin-right: 0.5rem;\n}\n\n.p-treetable-toggler + .p-checkbox {\n    vertical-align: middle;\n    margin-right: 0.5rem;\n}\n\n.p-treetable-toggler + .p-checkbox + span {\n    vertical-align: middle;\n}\n\n.p-treetable-toggler + .p-checkbox.p-indeterminate .p-checkbox-icon {\n    color: ").concat(dt('treetable.indeterminate.color'), ";\n}\n\n.p-treetable-toggler:enabled:hover {\n    background: ").concat(dt('treetable.toggle.hover.background'), ";\n    color: ").concat(dt('treetable.toggle.hover.color'), ";\n}\n\n.p-treetable-hoverable-rows .p-treetable-tbody > tr:not(.p-highlight):hover .p-treetable-toggler {\n    color: ").concat(dt('treetable.toggle.hover.color'), ";\n    background: transparent;\n}\n\n.p-treetable-tbody > tr.p-highlight .p-treetable-toggler {\n    color: inherit;\n}\n\n.p-treetable-tbody > tr.p-highlight .p-treetable-toggler:hover {\n    background: ").concat(dt('treetable.toggle.highlight.hover.background'), ";\n    color: inherit;\n}\n\n.p-treetable-tfoot > tr > td {\n    text-align: left;\n    padding: 0.75rem 1rem;\n    border: 1px solid ").concat(dt('treetable.footer.cell.border.color'), ";\n    border-width: 0 0 1px 0;\n    font-weight: 600;\n    color: ").concat(dt('treetable.footer.cell.color'), ";\n    background: ").concat(dt('treetable.footer.cell.background'), ";\n}\n\n.p-treetable .p-treetable-loading-icon {\n    font-size: 2rem;\n    width: 2rem;\n    height: 2rem;\n}\n\n.p-treetable-gridlines .p-treetable-header {\n    border-width: 1px 1px 0 1px;\n}\n\n.p-treetable-gridlines .p-treetable-footer {\n    border-width: 0 1px 1px 1px;\n}\n\n.p-treetable-gridlines .p-treetable-top {\n    border-width: 0 1px 0 1px;\n}\n\n.p-treetable-gridlines .p-treetable-bottom {\n    border-width: 0 1px 1px 1px;\n}\n\n.p-treetable-gridlines .p-treetable-thead > tr > th {\n    border-width: 1px;\n}\n\n.p-treetable-gridlines .p-treetable-tbody > tr > td {\n    border-width: 1px;\n}\n\n.p-treetable-gridlines .p-treetable-tfoot > tr > td {\n    border-width: 1px;\n}\n\n.p-treetable-sm .p-treetable-header {\n    padding: 0.65625rem 0.875rem;\n}\n\n.p-treetable-sm .p-treetable-thead > tr > th {\n    padding: 0.375rem 0.5rem;\n}\n\n.p-treetable-sm .p-treetable-tbody > tr > td {\n    padding: 0.375rem 0.5rem;\n}\n\n.p-treetable-sm .p-treetable-tfoot > tr > td {\n    padding: 0.375rem 0.5rem;\n}\n\n.p-treetable-sm .p-treetable-footer {\n    padding: 0.375rem 0.5rem;\n}\n\n.p-treetable-lg .p-treetable-header {\n    padding: 0.9375rem 1.25rem;\n}\n\n.p-treetable-lg .p-treetable-thead > tr > th {\n    padding: 0.9375rem 1.25rem;\n}\n\n.p-treetable-lg .p-treetable-tbody > tr > td {\n    padding: 0.9375rem 1.25rem;\n}\n\n.p-treetable-lg .p-treetable-tfoot > tr > td {\n    padding: 0.9375rem 1.25rem;\n}\n\n.p-treetable-lg .p-treetable-footer {\n    padding: 0.9375rem 1.25rem;\n}\n");
  }
};

module.exports = index;
